"use strict";

exports.__esModule = true;
exports.withContext = withContext;
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var server = typeof window === 'undefined' && require('./server');

function withContext(contextTypes) {
  if (contextTypes === void 0) {
    contextTypes = {};
  }

  var ProvideContext = server && server._makeProvider(contextTypes);

  var ServerBoundary =
  /*#__PURE__*/
  function (_PureComponent) {
    _inheritsLoose(ServerBoundary, _PureComponent);

    function ServerBoundary() {
      var _this;

      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      _this = _PureComponent.call.apply(_PureComponent, [this].concat(args)) || this;

      _defineProperty(_assertThisInitialized(_this), "state", {
        hasError: false
      });

      return _this;
    }

    var _proto = ServerBoundary.prototype;

    _proto.componentDidCatch = function componentDidCatch() {
      this.setState({
        hasError: true
      });
    };

    _proto.render = function render() {
      if (server) return server._render(this, ProvideContext);
      return _react.default.createElement("div", null, this.state.hasError ? this.props.fallBack() : this.props.children);
    };

    return ServerBoundary;
  }(_react.PureComponent);

  _defineProperty(ServerBoundary, "defaultProps", {
    fallBack: function fallBack() {
      return null;
    }
  });

  _defineProperty(ServerBoundary, "contextTypes", contextTypes);

  return ServerBoundary;
}

var _default = withContext();

exports.default = _default;